// Code generated by MockGen. DO NOT EDIT.
// Source: ./session_process_usecase.go

// Package mock is a generated GoMock package.
package mock

import (
	reflect "reflect"
	sessionprocess "sessionprocess"

	gomock "github.com/golang/mock/gomock"
	healthcheck "gitlab.com/commonground/blauwe-knop/health-checker/healthchecker"
)

// MockSessionRandomGenerator is a mock of SessionRandomGenerator interface.
type MockSessionRandomGenerator struct {
	ctrl     *gomock.Controller
	recorder *MockSessionRandomGeneratorMockRecorder
}

// MockSessionRandomGeneratorMockRecorder is the mock recorder for MockSessionRandomGenerator.
type MockSessionRandomGeneratorMockRecorder struct {
	mock *MockSessionRandomGenerator
}

// NewMockSessionRandomGenerator creates a new mock instance.
func NewMockSessionRandomGenerator(ctrl *gomock.Controller) *MockSessionRandomGenerator {
	mock := &MockSessionRandomGenerator{ctrl: ctrl}
	mock.recorder = &MockSessionRandomGeneratorMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockSessionRandomGenerator) EXPECT() *MockSessionRandomGeneratorMockRecorder {
	return m.recorder
}

// GenerateChallengeRandom mocks base method.
func (m *MockSessionRandomGenerator) GenerateChallengeRandom() string {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GenerateChallengeRandom")
	ret0, _ := ret[0].(string)
	return ret0
}

// GenerateChallengeRandom indicates an expected call of GenerateChallengeRandom.
func (mr *MockSessionRandomGeneratorMockRecorder) GenerateChallengeRandom() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GenerateChallengeRandom", reflect.TypeOf((*MockSessionRandomGenerator)(nil).GenerateChallengeRandom))
}

// GenerateSessionToken mocks base method.
func (m *MockSessionRandomGenerator) GenerateSessionToken() sessionprocess.SessionToken {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GenerateSessionToken")
	ret0, _ := ret[0].(sessionprocess.SessionToken)
	return ret0
}

// GenerateSessionToken indicates an expected call of GenerateSessionToken.
func (mr *MockSessionRandomGeneratorMockRecorder) GenerateSessionToken() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GenerateSessionToken", reflect.TypeOf((*MockSessionRandomGenerator)(nil).GenerateSessionToken))
}

// MockSessionRegisterRepository is a mock of SessionRegisterRepository interface.
type MockSessionRegisterRepository struct {
	ctrl     *gomock.Controller
	recorder *MockSessionRegisterRepositoryMockRecorder
}

// MockSessionRegisterRepositoryMockRecorder is the mock recorder for MockSessionRegisterRepository.
type MockSessionRegisterRepositoryMockRecorder struct {
	mock *MockSessionRegisterRepository
}

// NewMockSessionRegisterRepository creates a new mock instance.
func NewMockSessionRegisterRepository(ctrl *gomock.Controller) *MockSessionRegisterRepository {
	mock := &MockSessionRegisterRepository{ctrl: ctrl}
	mock.recorder = &MockSessionRegisterRepositoryMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockSessionRegisterRepository) EXPECT() *MockSessionRegisterRepositoryMockRecorder {
	return m.recorder
}

// CreateChallenge mocks base method.
func (m *MockSessionRegisterRepository) CreateChallenge(publicKeyFingerprint, publicKeyPem string) (*sessionprocess.Challenge, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "CreateChallenge", publicKeyFingerprint, publicKeyPem)
	ret0, _ := ret[0].(*sessionprocess.Challenge)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// CreateChallenge indicates an expected call of CreateChallenge.
func (mr *MockSessionRegisterRepositoryMockRecorder) CreateChallenge(publicKeyFingerprint, publicKeyPem interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "CreateChallenge", reflect.TypeOf((*MockSessionRegisterRepository)(nil).CreateChallenge), publicKeyFingerprint, publicKeyPem)
}

// CreateSession mocks base method.
func (m *MockSessionRegisterRepository) CreateSession(publicKeyPem string) (*sessionprocess.SessionToken, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "CreateSession", publicKeyPem)
	ret0, _ := ret[0].(*sessionprocess.SessionToken)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// CreateSession indicates an expected call of CreateSession.
func (mr *MockSessionRegisterRepositoryMockRecorder) CreateSession(publicKeyPem interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "CreateSession", reflect.TypeOf((*MockSessionRegisterRepository)(nil).CreateSession), publicKeyPem)
}

// GetChallenge mocks base method.
func (m *MockSessionRegisterRepository) GetChallenge(publicKeyFingerPrint string) (*sessionprocess.Challenge, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetChallenge", publicKeyFingerPrint)
	ret0, _ := ret[0].(*sessionprocess.Challenge)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// GetChallenge indicates an expected call of GetChallenge.
func (mr *MockSessionRegisterRepositoryMockRecorder) GetChallenge(publicKeyFingerPrint interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetChallenge", reflect.TypeOf((*MockSessionRegisterRepository)(nil).GetChallenge), publicKeyFingerPrint)
}

// GetHealthCheck mocks base method.
func (m *MockSessionRegisterRepository) GetHealthCheck() healthcheck.Result {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetHealthCheck")
	ret0, _ := ret[0].(healthcheck.Result)
	return ret0
}

// GetHealthCheck indicates an expected call of GetHealthCheck.
func (mr *MockSessionRegisterRepositoryMockRecorder) GetHealthCheck() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetHealthCheck", reflect.TypeOf((*MockSessionRegisterRepository)(nil).GetHealthCheck))
}
